package test.endlicherAutomat;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import alphabet.Wort;
import endlicherAutomat.EndlicherAutomat;
import regulaererAusdruck.RegulaererAusdruck;

public class AusdruckAusAutomat2Test {
  @Test
  public void testAudruckausAutomat() {
    
    /**** Regulaeren Ausdruck hier eintragen ****/
    
    String ausdruck = "("
          +"(a((a+b))*b)"
          +"+("
          + "((a+a((a+b))*b)+(a((a+b))*bb))"
          +   "("
          +   "(b((a+b))*b + (b((a+b))*b + a)b)"
          +   ")*"
          + "(b((a+b))*b + a)"
          + ")"
          + ")"
        ;
    
    

    String a2 = "a((a+b))*b";
    String a1 = "((a+" + a2 + ")+" + a2 + "b)";
    String a40 = "b((a+b))*b";
    String a4 = "(" + a40 + " +(" + a40 + "+a)b"  + ")";
    String a3 = "(" + a40 + "+a)";
    ausdruck = "(" + a2 + "+" + a1 + "(" + a4 + ")*" + a3 + ")";
    System.out.println(ausdruck);
    EndlicherAutomat ea = new EndlicherAutomat();
    ea.stringAlsAutomat("""
        % Automat_det
        Z: z0 z1 z2 z3
        E: z2
        S: z0
        A: a b
        z0 a z1
        z0 a z3
        z1 a z1
        z1 b z1
        z1 b z3
        z1 b z2
        z2 b z3
        z3 b z1
        z3 a z2
        """);
    ea.deterministisch().minimieren();
    EndlicherAutomat ea2 = RegulaererAusdruck.alsAusdruck(ausdruck).alsAutomat().deterministisch().minimieren();
    
    ea2.zustandsnamenKuerzen();
    System.out.println(ea2);
    boolean erg = ea.istMinimalIsomorph(ea2);
    Wort w = null;
    String text = "";
    if(!erg) {
      w = ea.nichtGemeinsamesWort(ea2);
      System.out.println(ea);
      text = util.Util.text(w) + " nicht korrekt bearbeitet,"
        +" Ihr Automat:" + ea2.akzeptieren(w) + " korrekt:" 
        + ea.akzeptieren(w);
    }
    Assertions.assertTrue(erg, text);
  }
}