package test.kontextfreieGrammatik;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;

import alphabet.Nichtterminal;
import alphabet.Terminal;
import alphabet.Zeichen;
import grammatik.KontextfreieGrammatik;
import zustand.Zustand;

public class KFGTrafo3Test {
  private KontextfreieGrammatik sut;

  @BeforeEach
  public void setUp() throws Exception {
    Zustand.reset();
    Terminal.reset();
    Nichtterminal.reset();
    Zeichen.reset();
    this.sut = new KontextfreieGrammatik();
    this.sut.dateiEinlesen(
        "beispiele" + util.Util.FS + "kontextfreiegrammatiken" + util.Util.FS + "KFGTrafo3.kfg");
  }
  
  @Test
  public void testStruktur() {
    Assertions.assertTrue(this.sut.istInChomskyNormalform());
  }

  @ParameterizedTest
  @ValueSource(
      strings = { "", "aa", "bb", "cc", "aabb", "aacc", "bbcc", "aabbcc"
          ,"ccaa", "ccbb","bbccaa","ccbbccbb", "bbccaaccaa"
          , "aaaabbbbcccc" })
  public void testOK(String wort) {
    boolean erg = this.sut.ableitbar(wort);
    Assertions.assertTrue(erg, "\"" + util.Util.text(wort) + "\""
        + " sollte ableitbar sein in\n");
  }

  // nach bb kann nicht direkt aa folgen
  @ParameterizedTest
  @ValueSource(
      strings = { "a", "aaa", "aaaaa", "b", "bbb", "aab", "aba"
          ,"aabbbaa", "aaabaaa", "c", "ccc", "ccaabbc", "bbaa"
          ,"ccaaccbbaacc"})
  public void testNicht(String wort) {
    boolean erg = this.sut.ableitbar(wort);
    Assertions.assertFalse(erg, "\"" + util.Util.text(wort) + "\""
        + " sollte nicht ableitbar sein in\n");
  }
}

